diff --git a/src/backend/optimizer/util/relnode.c b/src/backend/optimizer/util/relnode.c
new file mode 100644
index 342d884..308bdec
*** a/src/backend/optimizer/util/relnode.c
--- b/src/backend/optimizer/util/relnode.c
***************
*** 23,30 ****
--- 23,32 ----
  #include "optimizer/paths.h"
  #include "optimizer/placeholder.h"
  #include "optimizer/plancat.h"
+ #include "optimizer/prep.h"
  #include "optimizer/restrictinfo.h"
  #include "optimizer/tlist.h"
+ #include "optimizer/var.h"
  #include "utils/hsearch.h"
  
  
*************** typedef struct JoinHashEntry
*** 35,41 ****
  } JoinHashEntry;
  
  static void build_joinrel_tlist(PlannerInfo *root, RelOptInfo *joinrel,
! 					RelOptInfo *input_rel);
  static List *build_joinrel_restrictlist(PlannerInfo *root,
  						   RelOptInfo *joinrel,
  						   RelOptInfo *outer_rel,
--- 37,43 ----
  } JoinHashEntry;
  
  static void build_joinrel_tlist(PlannerInfo *root, RelOptInfo *joinrel,
! 								RelOptInfo *input_rel, bool grouped);
  static List *build_joinrel_restrictlist(PlannerInfo *root,
  						   RelOptInfo *joinrel,
  						   RelOptInfo *outer_rel,
*************** static List *subbuild_joinrel_joinlist(R
*** 52,57 ****
--- 54,64 ----
  static void set_foreign_rel_properties(RelOptInfo *joinrel,
  						   RelOptInfo *outer_rel, RelOptInfo *inner_rel);
  static void add_join_rel(PlannerInfo *root, RelOptInfo *joinrel);
+ extern ParamPathInfo *find_param_path_info(RelOptInfo *rel,
+ 									  Relids required_outer);
+ static void build_joinrel_partition_info(RelOptInfo *joinrel,
+ 							 RelOptInfo *outer_rel, RelOptInfo *inner_rel,
+ 							 List *restrictlist, JoinType jointype);
  
  
  /*
*************** build_simple_rel(PlannerInfo *root, int
*** 120,125 ****
--- 127,133 ----
  	rel->cheapest_parameterized_paths = NIL;
  	rel->direct_lateral_relids = NULL;
  	rel->lateral_relids = NULL;
+ 	rel->gpi = NULL;
  	rel->relid = relid;
  	rel->rtekind = rte->rtekind;
  	/* min_attr, max_attr, attr_needed, attr_widths are set below */
*************** build_simple_rel(PlannerInfo *root, int
*** 146,151 ****
--- 154,164 ----
  	rel->baserestrict_min_security = UINT_MAX;
  	rel->joininfo = NIL;
  	rel->has_eclass_joins = false;
+ 	rel->part_scheme = NULL;
+ 	rel->nparts = 0;
+ 	rel->boundinfo = NULL;
+ 	rel->partexprs = NULL;
+ 	rel->part_rels = NULL;
  
  	/*
  	 * Pass top parent's relids down the inheritance hierarchy. If the parent
*************** build_simple_rel(PlannerInfo *root, int
*** 218,237 ****
  	if (rte->inh)
  	{
  		ListCell   *l;
  
  		foreach(l, root->append_rel_list)
  		{
  			AppendRelInfo *appinfo = (AppendRelInfo *) lfirst(l);
  
  			/* append_rel_list contains all append rels; ignore others */
  			if (appinfo->parent_relid != relid)
  				continue;
  
! 			(void) build_simple_rel(root, appinfo->child_relid,
! 									rel);
  		}
  	}
  
  	return rel;
  }
  
--- 231,293 ----
  	if (rte->inh)
  	{
  		ListCell   *l;
+ 		int			nparts = rel->nparts;
+ 
+ 		if (nparts > 0)
+ 			rel->part_rels = (RelOptInfo **) palloc0(sizeof(RelOptInfo *) * nparts);
  
  		foreach(l, root->append_rel_list)
  		{
  			AppendRelInfo *appinfo = (AppendRelInfo *) lfirst(l);
+ 			RelOptInfo *childrel;
+ 			int			cnt_parts;
+ 			RangeTblEntry *childRTE;
  
  			/* append_rel_list contains all append rels; ignore others */
  			if (appinfo->parent_relid != relid)
  				continue;
  
! 			childrel = build_simple_rel(root, appinfo->child_relid,
! 										 rel);
! 
! 			/* Nothing more to do for an unpartitioned table. */
! 			if (!rel->part_scheme)
! 				continue;
! 
! 			childRTE = root->simple_rte_array[appinfo->child_relid];
! 			/*
! 			 * Two partitioned tables with the same partitioning scheme, have
! 			 * their partition bounds arranged in the same order. The order of
! 			 * partition OIDs in RelOptInfo corresponds to the partition bound
! 			 * order. Thus the OIDs of matching partitions from both the tables
! 			 * are placed at the same position in the array of partition OIDs
! 			 * in the respective RelOptInfos. Arranging RelOptInfos of
! 			 * partitions in the same order as their OIDs makes it easy to find
! 			 * the RelOptInfos of matching partitions for partition-wise join.
! 			 */
! 			for (cnt_parts = 0; cnt_parts < nparts; cnt_parts++)
! 			{
! 				if (rel->part_oids[cnt_parts] == childRTE->relid)
! 				{
! 					Assert(!rel->part_rels[cnt_parts]);
! 					rel->part_rels[cnt_parts] = childrel;
! 					break;
! 				}
! 			}
  		}
  	}
  
+ 	/* Should have found all the childrels of a partitioned relation. */
+ 	if (rel->part_scheme)
+ 	{
+ 		int		cnt_parts;
+ 
+ 		for (cnt_parts = 0; cnt_parts < rel->nparts; cnt_parts++)
+ 			if (!rel->part_rels[cnt_parts])
+ 				elog(ERROR, "could not find the RelOptInfo of a partition with oid %u",
+ 					 rel->part_oids[cnt_parts]);
+ 	}
+ 
  	return rel;
  }
  
*************** build_join_rel(PlannerInfo *root,
*** 453,458 ****
--- 509,517 ----
  	RelOptInfo *joinrel;
  	List	   *restrictlist;
  
+ 	/* This function should be used only for join between parents. */
+ 	Assert(!IS_OTHER_REL(outer_rel) && !IS_OTHER_REL(inner_rel));
+ 
  	/*
  	 * See if we already have a joinrel for this set of base rels.
  	 */
*************** build_join_rel(PlannerInfo *root,
*** 497,502 ****
--- 556,562 ----
  				  inner_rel->direct_lateral_relids);
  	joinrel->lateral_relids = min_join_parameterization(root, joinrel->relids,
  														outer_rel, inner_rel);
+ 	joinrel->gpi = NULL;
  	joinrel->relid = 0;			/* indicates not a baserel */
  	joinrel->rtekind = RTE_JOIN;
  	joinrel->min_attr = 0;
*************** build_join_rel(PlannerInfo *root,
*** 527,532 ****
--- 587,597 ----
  	joinrel->joininfo = NIL;
  	joinrel->has_eclass_joins = false;
  	joinrel->top_parent_relids = NULL;
+ 	joinrel->part_scheme = NULL;
+ 	joinrel->nparts = 0;
+ 	joinrel->boundinfo = NULL;
+ 	joinrel->partexprs = NULL;
+ 	joinrel->part_rels = NULL;
  
  	/* Compute information relevant to the foreign relations. */
  	set_foreign_rel_properties(joinrel, outer_rel, inner_rel);
*************** build_join_rel(PlannerInfo *root,
*** 539,548 ****
  	 * and inner rels we first try to build it from.  But the contents should
  	 * be the same regardless.
  	 */
! 	build_joinrel_tlist(root, joinrel, outer_rel);
! 	build_joinrel_tlist(root, joinrel, inner_rel);
  	add_placeholders_to_joinrel(root, joinrel, outer_rel, inner_rel);
  
  	/*
  	 * add_placeholders_to_joinrel also took care of adding the ph_lateral
  	 * sets of any PlaceHolderVars computed here to direct_lateral_relids, so
--- 604,620 ----
  	 * and inner rels we first try to build it from.  But the contents should
  	 * be the same regardless.
  	 */
! 	build_joinrel_tlist(root, joinrel, outer_rel, false);
! 	build_joinrel_tlist(root, joinrel, inner_rel, false);
  	add_placeholders_to_joinrel(root, joinrel, outer_rel, inner_rel);
  
+ 	/* Try to build grouped target. */
+ 	/*
+ 	 * TODO Consider if placeholders make sense here. If not, also make the
+ 	 * related code below conditional.
+ 	 */
+ 	prepare_rel_for_grouping(root, joinrel);
+ 
  	/*
  	 * add_placeholders_to_joinrel also took care of adding the ph_lateral
  	 * sets of any PlaceHolderVars computed here to direct_lateral_relids, so
*************** build_join_rel(PlannerInfo *root,
*** 572,577 ****
--- 644,653 ----
  	 */
  	joinrel->has_eclass_joins = has_relevant_eclass_joinclause(root, joinrel);
  
+ 	/* Store the partition information. */
+ 	build_joinrel_partition_info(joinrel, outer_rel, inner_rel, restrictlist,
+ 								 sjinfo->jointype);
+ 
  	/*
  	 * Set estimates of the joinrel's size.
  	 */
*************** build_join_rel(PlannerInfo *root,
*** 617,622 ****
--- 693,845 ----
  	return joinrel;
  }
  
+  /*
+  * build_child_join_rel
+  *		Builds RelOptInfo for joining given two child relations from RelOptInfo
+  *		representing the join between their parents.
+  *
+  * 'outer_rel' and 'inner_rel' are the RelOptInfos of child relations being
+  *		joined.
+  * 'parent_joinrel' is the RelOptInfo representing the join between parent
+  *		relations. Most of the members of new RelOptInfo are produced by
+  *		translating corresponding members of this RelOptInfo.
+  * 'sjinfo': context info for child join
+  * 'restrictlist': list of RestrictInfo nodes that apply to this particular
+  *		pair of joinable relations.
+  * 'join_appinfos': list of AppendRelInfo nodes for base child relations involved
+  *		in this join.
+  */
+ RelOptInfo *
+ build_child_join_rel(PlannerInfo *root, RelOptInfo *outer_rel,
+ 					 RelOptInfo *inner_rel, RelOptInfo *parent_joinrel,
+ 					 List *restrictlist, SpecialJoinInfo *sjinfo,
+ 					 JoinType jointype)
+ {
+ 	RelOptInfo *joinrel = makeNode(RelOptInfo);
+ 	AppendRelInfo **appinfos;
+ 	int		nappinfos;
+ 
+ 	/* Only joins between other relations land here. */
+ 	Assert(IS_OTHER_REL(outer_rel) && IS_OTHER_REL(inner_rel));
+ 
+ 	joinrel->reloptkind = RELOPT_OTHER_JOINREL;
+ 	joinrel->relids = bms_union(outer_rel->relids, inner_rel->relids);
+ 	joinrel->rows = 0;
+ 	/* cheap startup cost is interesting iff not all tuples to be retrieved */
+ 	joinrel->consider_startup = (root->tuple_fraction > 0);
+ 	joinrel->consider_param_startup = false;
+ 	joinrel->consider_parallel = false;
+ 	joinrel->reltarget = create_empty_pathtarget();
+ 	joinrel->pathlist = NIL;
+ 	joinrel->ppilist = NIL;
+ 	joinrel->partial_pathlist = NIL;
+ 	joinrel->cheapest_startup_path = NULL;
+ 	joinrel->cheapest_total_path = NULL;
+ 	joinrel->cheapest_unique_path = NULL;
+ 	joinrel->cheapest_parameterized_paths = NIL;
+ 	joinrel->direct_lateral_relids = NULL;
+ 	joinrel->lateral_relids = NULL;
+ 	joinrel->gpi = makeNode(GroupedPathInfo);
+ 	if (parent_joinrel->gpi)
+ 		/*
+ 		 * Translation into child varnos will take place along with other
+ 		 * translations, see try_partition_wise_join.
+ 		 */
+ 		joinrel->gpi->target = copy_pathtarget(parent_joinrel->gpi->target);
+ 	joinrel->relid = 0;			/* indicates not a baserel */
+ 	joinrel->rtekind = RTE_JOIN;
+ 	joinrel->min_attr = 0;
+ 	joinrel->max_attr = 0;
+ 	joinrel->attr_needed = NULL;
+ 	joinrel->attr_widths = NULL;
+ 	joinrel->lateral_vars = NIL;
+ 	joinrel->lateral_referencers = NULL;
+ 	joinrel->indexlist = NIL;
+ 	joinrel->pages = 0;
+ 	joinrel->tuples = 0;
+ 	joinrel->allvisfrac = 0;
+ 	joinrel->subroot = NULL;
+ 	joinrel->subplan_params = NIL;
+ 	joinrel->serverid = InvalidOid;
+ 	joinrel->userid = InvalidOid;
+ 	joinrel->useridiscurrent = false;
+ 	joinrel->fdwroutine = NULL;
+ 	joinrel->fdw_private = NULL;
+ 	joinrel->baserestrictinfo = NIL;
+ 	joinrel->baserestrictcost.startup = 0;
+ 	joinrel->baserestrictcost.per_tuple = 0;
+ 	joinrel->joininfo = NIL;
+ 	joinrel->has_eclass_joins = false;
+ 	joinrel->top_parent_relids = NULL;
+ 	joinrel->part_scheme = NULL;
+ 	joinrel->part_rels = NULL;
+ 	joinrel->partexprs = NULL;
+ 
+ 	joinrel->top_parent_relids = bms_union(outer_rel->top_parent_relids,
+ 										   inner_rel->top_parent_relids);
+ 
+ 	/* Compute information relevant to foreign relations. */
+ 	set_foreign_rel_properties(joinrel, outer_rel, inner_rel);
+ 
+ 	/* Build targetlist */
+ 	build_joinrel_tlist(root, joinrel, outer_rel, false);
+ 	build_joinrel_tlist(root, joinrel, inner_rel, false);
+ 	/* Add placeholder variables. */
+ 	add_placeholders_to_child_joinrel(root, joinrel, parent_joinrel);
+ 
+ 	/* Try to build grouped target. */
+ 	/*
+ 	 * TODO Consider if placeholders make sense here. If not, also make the
+ 	 * related code below conditional.
+ 	 */
+ 	prepare_rel_for_grouping(root, joinrel);
+ 
+ 
+ 	/* Construct joininfo list. */
+ 	appinfos = find_appinfos_by_relids(root, joinrel->relids, &nappinfos);
+ 	joinrel->joininfo = (List *) adjust_appendrel_attrs(root,
+ 											 (Node *) parent_joinrel->joininfo,
+ 																	 nappinfos,
+ 																	 appinfos);
+ 	pfree(appinfos);
+ 
+ 	/*
+ 	 * Lateral relids referred in child join will be same as that referred in
+ 	 * the parent relation. Throw any partial result computed while building
+ 	 * the targetlist.
+ 	 */
+ 	bms_free(joinrel->direct_lateral_relids);
+ 	bms_free(joinrel->lateral_relids);
+ 	joinrel->direct_lateral_relids = (Relids) bms_copy(parent_joinrel->direct_lateral_relids);
+ 	joinrel->lateral_relids = (Relids) bms_copy(parent_joinrel->lateral_relids);
+ 
+ 	/*
+ 	 * If the parent joinrel has pending equivalence classes, so does the
+ 	 * child.
+ 	 */
+ 	joinrel->has_eclass_joins = parent_joinrel->has_eclass_joins;
+ 
+ 	/* Is the join between partitions itself partitioned? */
+ 	build_joinrel_partition_info(joinrel, outer_rel, inner_rel, restrictlist,
+ 								 jointype);
+ 
+ 	/* Child joinrel is parallel safe if parent is parallel safe. */
+ 	joinrel->consider_parallel = parent_joinrel->consider_parallel;
+ 
+ 
+ 	/* Set estimates of the child-joinrel's size. */
+ 	set_joinrel_size_estimates(root, joinrel, outer_rel, inner_rel,
+ 							   sjinfo, restrictlist);
+ 
+ 	/* We build the join only once. */
+ 	Assert(!find_join_rel(root, joinrel->relids));
+ 
+ 	/* Add the relation to the PlannerInfo. */
+ 	add_join_rel(root, joinrel);
+ 
+ 	return joinrel;
+ }
+ 
  /*
   * min_join_parameterization
   *
*************** min_join_parameterization(PlannerInfo *r
*** 670,679 ****
   */
  static void
  build_joinrel_tlist(PlannerInfo *root, RelOptInfo *joinrel,
! 					RelOptInfo *input_rel)
  {
! 	Relids		relids = joinrel->relids;
  	ListCell   *vars;
  
  	foreach(vars, input_rel->reltarget->exprs)
  	{
--- 893,932 ----
   */
  static void
  build_joinrel_tlist(PlannerInfo *root, RelOptInfo *joinrel,
! 					RelOptInfo *input_rel, bool grouped)
  {
! 	Relids		relids;
! 	PathTarget  *input_target, *result;
  	ListCell   *vars;
+ 	int			i = -1;
+ 
+ 	/* attrs_needed refers to parent relids and not those of a child. */
+ 	if (joinrel->top_parent_relids)
+ 		relids = joinrel->top_parent_relids;
+ 	else
+ 		relids = joinrel->relids;
+ 
+  	if (!grouped)
+  	{
+  		input_target = input_rel->reltarget;
+  		result = joinrel->reltarget;
+  	}
+  	else
+  	{
+  		if (input_rel->gpi != NULL)
+  		{
+  			input_target = input_rel->gpi->target;
+  			Assert(input_target != NULL);
+  		}
+  		else
+  			input_target = input_rel->reltarget;
+ 
+  		/* Caller should have initialized this. */
+  		Assert(joinrel->gpi != NULL);
+ 
+  		/* Default to the plain target. */
+  		result = joinrel->gpi->target;
+  	}
  
  	foreach(vars, input_rel->reltarget->exprs)
  	{
*************** build_joinrel_tlist(PlannerInfo *root, R
*** 690,713 ****
  
  		/*
  		 * Otherwise, anything in a baserel or joinrel targetlist ought to be
! 		 * a Var.  (More general cases can only appear in appendrel child
! 		 * rels, which will never be seen here.)
  		 */
! 		if (!IsA(var, Var))
  			elog(ERROR, "unexpected node type in rel targetlist: %d",
  				 (int) nodeTag(var));
  
- 		/* Get the Var's original base rel */
- 		baserel = find_base_rel(root, var->varno);
- 
- 		/* Is it still needed above this joinrel? */
- 		ndx = var->varattno - baserel->min_attr;
  		if (bms_nonempty_difference(baserel->attr_needed[ndx], relids))
  		{
  			/* Yup, add it to the output */
! 			joinrel->reltarget->exprs = lappend(joinrel->reltarget->exprs, var);
! 			/* Vars have cost zero, so no need to adjust reltarget->cost */
! 			joinrel->reltarget->width += baserel->attr_widths[ndx];
  		}
  	}
  }
--- 943,1009 ----
  
  		/*
  		 * Otherwise, anything in a baserel or joinrel targetlist ought to be
! 		 * a Var or ConvertRowtypeExpr introduced while translating parent
! 		 * targetlist to that of the child.
  		 */
! 		if (IsA(var, Var))
! 		{
! 			/* Get the Var's original base rel */
! 			baserel = find_base_rel(root, var->varno);
! 
! 			/* Is it still needed above this joinrel? */
! 			ndx = var->varattno - baserel->min_attr;
! 		}
! 		else if (IsA(var, ConvertRowtypeExpr))
! 		{
! 			ConvertRowtypeExpr *child_expr = (ConvertRowtypeExpr *) var;
! 			Var	 *childvar = (Var *) child_expr->arg;
! 
! 			/*
! 			 * Child's whole-row references are converted to that of parent
! 			 * using ConvertRowtypeExpr. There can be as many
! 			 * ConvertRowtypeExpr decorations as the depth of partition tree.
! 			 * The argument to deepest ConvertRowtypeExpr is expected to be a
! 			 * whole-row reference of the child.
! 			 */
! 			while (IsA(childvar, ConvertRowtypeExpr))
! 			{
! 				child_expr = (ConvertRowtypeExpr *) childvar;
! 				childvar = (Var *) child_expr->arg;
! 			}
! 			Assert(IsA(childvar, Var) && childvar->varattno == 0);
! 
! 			baserel = find_base_rel(root, childvar->varno);
! 			ndx = 0 - baserel->min_attr;
! 		}
! 		else
  			elog(ERROR, "unexpected node type in rel targetlist: %d",
  				 (int) nodeTag(var));
  
  		if (bms_nonempty_difference(baserel->attr_needed[ndx], relids))
  		{
+ 			Index sortgroupref = 0;
+ 
  			/* Yup, add it to the output */
! 			if (input_target->sortgrouprefs)
! 				sortgroupref = input_target->sortgrouprefs[i];
! 
! 			/*
! 			 * Even if not used for grouping in the input path (the input path
! 			 * is not necessarily grouped), it might be useful for grouping
! 			 * higher in the join tree.
! 			 */
! 			if (sortgroupref == 0)
! 				sortgroupref = get_expr_sortgroupref(root, (Expr *) var);
! 
! 			add_column_to_pathtarget(result, (Expr *) var, sortgroupref);
! 
! 			/*
! 			 * Vars have cost zero, so no need to adjust reltarget->cost. Even
! 			 * if, it's a ConvertRowtypeExpr, it will be computed only for the
! 			 * base relation, costing nothing for a join.
! 			 */
! 			result->width += baserel->attr_widths[ndx];
  		}
  	}
  }
*************** subbuild_joinrel_joinlist(RelOptInfo *jo
*** 843,848 ****
--- 1139,1147 ----
  {
  	ListCell   *l;
  
+ 	/* Expected to be called only for join between parent relations. */
+ 	Assert(joinrel->reloptkind == RELOPT_JOINREL);
+ 
  	foreach(l, joininfo_list)
  	{
  		RestrictInfo *rinfo = (RestrictInfo *) lfirst(l);
*************** get_baserel_parampathinfo(PlannerInfo *r
*** 1048,1059 ****
  	Assert(!bms_overlap(baserel->relids, required_outer));
  
  	/* If we already have a PPI for this parameterization, just return it */
! 	foreach(lc, baserel->ppilist)
! 	{
! 		ppi = (ParamPathInfo *) lfirst(lc);
! 		if (bms_equal(ppi->ppi_req_outer, required_outer))
! 			return ppi;
! 	}
  
  	/*
  	 * Identify all joinclauses that are movable to this base rel given this
--- 1347,1354 ----
  	Assert(!bms_overlap(baserel->relids, required_outer));
  
  	/* If we already have a PPI for this parameterization, just return it */
! 	if ((ppi = find_param_path_info(baserel, required_outer)))
! 		return ppi;
  
  	/*
  	 * Identify all joinclauses that are movable to this base rel given this
*************** get_baserel_parampathinfo(PlannerInfo *r
*** 1095,1100 ****
--- 1390,1545 ----
  }
  
  /*
+  * If the relation can produce grouped paths, create GroupedPathInfo for it
+  * and create target for the grouped paths.
+  */
+ void
+ prepare_rel_for_grouping(PlannerInfo *root, RelOptInfo *rel)
+ {
+ 	List	*rel_aggregates;
+ 	Relids	rel_agg_attrs = NULL;
+ 	List	*rel_agg_vars = NIL;
+ 	bool	found_higher;
+ 	ListCell	*lc;
+ 	PathTarget	*target_grouped;
+ 
+ 	if (rel->relid > 0)
+ 	{
+ 		RangeTblEntry *rte = root->simple_rte_array[rel->relid];;
+ 
+ 		/*
+ 		 * rtekind != RTE_RELATION case is not supported yet.
+ 		 */
+ 		if (rte->rtekind != RTE_RELATION)
+ 			return;
+ 	}
+ 
+ 	/* Caller should only pass base relations or joins. */
+ 	Assert(rel->reloptkind == RELOPT_BASEREL ||
+ 		   rel->reloptkind == RELOPT_JOINREL ||
+ 		   rel->reloptkind == RELOPT_OTHER_JOINREL);
+ 
+ 	/*
+ 	 * If any outer join can set the attribute value to NULL, the aggregate
+ 	 * would receive different input at the base rel level.
+ 	 *
+ 	 * TODO For RELOPT_JOINREL, do not return if all the joins that can set
+ 	 * any entry of the grouped target (do we need to postpone this check
+ 	 * until the grouped target is available, and should create_grouped_target
+ 	 * take care?) of this rel to NULL are provably below rel. (It's ok if rel
+ 	 * is one of these joins.)
+ 	 */
+ 	if (bms_overlap(rel->relids, root->nullable_baserels))
+ 		return;
+ 
+ 	/*
+ 	 * Check if some aggregates can be evaluated in this relation's target,
+ 	 * and collect all vars referenced by these aggregates.
+ 	 */
+ 	rel_aggregates = NIL;
+ 	found_higher = false;
+ 	foreach(lc, root->grouped_var_list)
+ 	{
+ 		GroupedVarInfo	*gvi = castNode(GroupedVarInfo, lfirst(lc));
+ 
+ 		/*
+ 		 * The subset includes gv_eval_at uninitialized, which typically means
+ 		 * Aggref.aggstar.
+ 		 */
+ 		if (bms_is_subset(gvi->gv_eval_at, rel->relids))
+ 		{
+ 			Aggref	*aggref = castNode(Aggref, gvi->gvexpr);
+ 
+ 			/*
+ 			 * Accept the aggregate.
+ 			 *
+ 			 * GroupedVarInfo is more convenient for the next processing than
+ 			 * Aggref, see add_aggregates_to_grouped_target.
+ 			 */
+ 			rel_aggregates = lappend(rel_aggregates, gvi);
+ 
+ 			if (rel->relid > 0)
+ 			{
+ 				/*
+ 				 * Simple relation. Collect attributes referenced by the
+ 				 * aggregate arguments.
+ 				 */
+ 				pull_varattnos((Node *) aggref, rel->relid, &rel_agg_attrs);
+ 			}
+ 			else
+ 			{
+ 				List	*agg_vars;
+ 
+ 				/*
+ 				 * Join. Collect vars referenced by the aggregate
+ 				 * arguments.
+ 				 */
+ 				/*
+ 				 * TODO Can any argument contain PHVs? And if so, does it matter?
+ 				 * Consider PVC_INCLUDE_PLACEHOLDERS | PVC_RECURSE_PLACEHOLDERS.
+ 				 */
+ 				agg_vars = pull_var_clause((Node *) aggref,
+ 										   PVC_RECURSE_AGGREGATES);
+ 				rel_agg_vars = list_concat(rel_agg_vars, agg_vars);
+ 			}
+ 		}
+ 		else if (bms_overlap(gvi->gv_eval_at, rel->relids))
+ 		{
+ 			/*
+ 			 * Remember that there is at least one aggregate that needs more
+ 			 * than this rel.
+ 			 */
+ 			found_higher = true;
+ 		}
+ 	}
+ 
+ 	/*
+ 	 * Grouping makes little sense w/o aggregate function.
+ 	 */
+ 	if (rel_aggregates == NIL)
+ 	{
+ 		bms_free(rel_agg_attrs);
+ 		return;
+ 	}
+ 
+ 	if (found_higher)
+ 	{
+ 		/*
+ 		 * If some aggregate(s) need only this rel but some other need
+ 		 * multiple relations including the the current one, grouping of the
+ 		 * current rel could steal some input variables from the "higher
+ 		 * aggregate" (besides decreasing the number of input rows).
+ 		 */
+ 		list_free(rel_aggregates);
+ 		bms_free(rel_agg_attrs);
+ 		return;
+ 	}
+ 
+ 	/*
+ 	 * If rel->reltarget can be used for aggregation, mark the relation as
+ 	 * capable of grouping.
+ 	 */
+ 	Assert(rel->gpi == NULL);
+ 	target_grouped = create_grouped_target(root, rel, rel_agg_attrs,
+ 										   rel_agg_vars);
+ 	if (target_grouped != NULL)
+ 	{
+ 		GroupedPathInfo	*gpi;
+ 
+ 		gpi = makeNode(GroupedPathInfo);
+ 		gpi->target = copy_pathtarget(target_grouped);
+ 		gpi->pathlist = NIL;
+ 		gpi->partial_pathlist = NIL;
+ 		rel->gpi = gpi;
+ 
+ 		/*
+ 		 * Add aggregates (in the form of GroupedVar) to the target.
+ 		 */
+ 		add_aggregates_to_target(root, gpi->target, rel_aggregates, rel);
+ 	}
+ }
+ 
+ /*
   * get_joinrel_parampathinfo
   *		Get the ParamPathInfo for a parameterized path for a join relation,
   *		constructing one if we don't have one already.
*************** get_joinrel_parampathinfo(PlannerInfo *r
*** 1290,1301 ****
  	*restrict_clauses = list_concat(pclauses, *restrict_clauses);
  
  	/* If we already have a PPI for this parameterization, just return it */
! 	foreach(lc, joinrel->ppilist)
! 	{
! 		ppi = (ParamPathInfo *) lfirst(lc);
! 		if (bms_equal(ppi->ppi_req_outer, required_outer))
! 			return ppi;
! 	}
  
  	/* Estimate the number of rows returned by the parameterized join */
  	rows = get_parameterized_joinrel_size(root, joinrel,
--- 1735,1742 ----
  	*restrict_clauses = list_concat(pclauses, *restrict_clauses);
  
  	/* If we already have a PPI for this parameterization, just return it */
! 	if ((ppi = find_param_path_info(joinrel, required_outer)))
! 		return ppi;
  
  	/* Estimate the number of rows returned by the parameterized join */
  	rows = get_parameterized_joinrel_size(root, joinrel,
*************** ParamPathInfo *
*** 1334,1340 ****
  get_appendrel_parampathinfo(RelOptInfo *appendrel, Relids required_outer)
  {
  	ParamPathInfo *ppi;
- 	ListCell   *lc;
  
  	/* Unparameterized paths have no ParamPathInfo */
  	if (bms_is_empty(required_outer))
--- 1775,1780 ----
*************** get_appendrel_parampathinfo(RelOptInfo *
*** 1343,1354 ****
  	Assert(!bms_overlap(appendrel->relids, required_outer));
  
  	/* If we already have a PPI for this parameterization, just return it */
! 	foreach(lc, appendrel->ppilist)
! 	{
! 		ppi = (ParamPathInfo *) lfirst(lc);
! 		if (bms_equal(ppi->ppi_req_outer, required_outer))
! 			return ppi;
! 	}
  
  	/* Else build the ParamPathInfo */
  	ppi = makeNode(ParamPathInfo);
--- 1783,1790 ----
  	Assert(!bms_overlap(appendrel->relids, required_outer));
  
  	/* If we already have a PPI for this parameterization, just return it */
! 	if ((ppi = find_param_path_info(appendrel, required_outer)))
! 		return ppi;
  
  	/* Else build the ParamPathInfo */
  	ppi = makeNode(ParamPathInfo);
*************** get_appendrel_parampathinfo(RelOptInfo *
*** 1359,1361 ****
--- 1795,1917 ----
  
  	return ppi;
  }
+ 
+ /*
+  * Returns a ParamPathInfo for outer relations specified by required_outer, if
+  * already available in the given rel. Returns NULL otherwise.
+  */
+ ParamPathInfo *
+ find_param_path_info(RelOptInfo *rel, Relids required_outer)
+ {
+ 	ListCell   *lc;
+ 
+ 	foreach(lc, rel->ppilist)
+ 	{
+ 		ParamPathInfo  *ppi = (ParamPathInfo *) lfirst(lc);
+ 		if (bms_equal(ppi->ppi_req_outer, required_outer))
+ 			return ppi;
+ 	}
+ 
+ 	return NULL;
+ }
+ 
+ /*
+  * build_joinrel_partition_info
+  *		If the join between given partitioned relations is possibly partitioned
+  *		set the partitioning scheme and partition keys expressions for the
+  *		join.
+  *
+  * If the two relations have same partitioning scheme, their join may be
+  * partitioned and will follow the same partitioning scheme as the joining
+  * relations.
+  */
+ static void
+ build_joinrel_partition_info(RelOptInfo *joinrel, RelOptInfo *outer_rel,
+ 							 RelOptInfo *inner_rel, List *restrictlist,
+ 							 JoinType jointype)
+ {
+ 	int		num_pks;
+ 	int		cnt;
+ 	bool	is_strict;
+ 
+ 	/* Nothing to do if partition-wise join technique is disabled. */
+ 	if (!enable_partition_wise_join)
+ 	{
+ 		joinrel->part_scheme = NULL;
+ 		return;
+ 	}
+ 
+ 	/*
+ 	 * The join is not partitioned, if any of the relations being joined are
+ 	 * not partitioned or they do not have same partitioning scheme or if there
+ 	 * is no equi-join between partition keys.
+ 	 *
+ 	 * For an N-way inner join, where every syntactic inner join has equi-join
+ 	 * between partition keys and a matching partitioning scheme, partition
+ 	 * keys of N relations form an equivalence class, thus inducing an
+ 	 * equi-join between any pair of joining relations.
+ 	 *
+ 	 * For an N-way join with outer joins, where every syntactic join has an
+ 	 * equi-join between partition keys and a matching partitioning scheme,
+ 	 * outer join reordering identities in optimizer/README imply that only
+ 	 * those pairs of join are legal which have an equi-join between partition
+ 	 * keys. Thus every pair of joining relations we see here should have an
+ 	 * equi-join if this join has been deemed as a partitioned join.
+ 	 */
+ 	if (!outer_rel->part_scheme || !inner_rel->part_scheme ||
+ 		outer_rel->part_scheme != inner_rel->part_scheme ||
+ 		!have_partkey_equi_join(outer_rel, inner_rel, jointype, restrictlist,
+ 								&is_strict))
+ 	{
+ 		joinrel->part_scheme = NULL;
+ 		return;
+ 	}
+ 
+ 	/*
+ 	 * This function will be called only once for each joinrel, hence it should
+ 	 * not have partition scheme, partition key expressions and array for
+ 	 * storing child relations set.
+ 	 */
+ 	Assert(!joinrel->part_scheme && !joinrel->partexprs &&
+ 		   !joinrel->part_rels);
+ 
+ 	/*
+ 	 * Join relation is partitioned using same partitioning scheme as the
+ 	 * joining relations.
+ 	 */
+ 	joinrel->part_scheme = outer_rel->part_scheme;
+ 	num_pks = joinrel->part_scheme->partnatts;
+ 
+ 	/*
+ 	 * Construct partition keys for the join.
+ 	 *
+ 	 * An INNER join between two partitioned relations is partition by key
+ 	 * expressions from both the relations. For tables A and B partitioned by a
+ 	 * and b respectively, (A INNER JOIN B ON A.a = B.b) is partitioned by both
+ 	 * A.a and B.b.
+ 	 *
+ 	 * An OUTER join like (A LEFT JOIN B ON A.a = B.b) may produce rows with
+ 	 * B.b NULL. These rows may not fit the partitioning conditions imposed on
+ 	 * B.b. Hence, strictly speaking, the join is not partitioned by B.b.
+ 	 * Strictly speaking, partition keys of an OUTER join should include
+ 	 * partition key expressions from the OUTER side only. Consider a join like
+ 	 * (A LEFT JOIN B on (A.a = B.b) LEFT JOIN C ON B.b = C.c. If we do not
+ 	 * include B.b as partition key expression for (AB), it prohibits us from
+ 	 * using partition-wise join when joining (AB) with C as there is no
+ 	 * equi-join between partition keys of joining relations. If the equality
+ 	 * operator is strict, two NULL values are never equal and no two rows from
+ 	 * mis-matching partitions can join. Hence if the equality operator is
+ 	 * strict it's safe to include B.b as partition key expression for (AB),
+ 	 * even though rows in (AB) are not strictly partitioned by B.b.
+ 	 */
+ 	joinrel->partexprs = (List **) palloc0(sizeof(List *) * num_pks);
+ 	for (cnt = 0; cnt < num_pks; cnt++)
+ 	{
+ 		List *pkexpr = list_copy(outer_rel->partexprs[cnt]);
+ 
+ 		if (jointype == JOIN_INNER || is_strict)
+ 			pkexpr = list_concat(pkexpr,
+ 								 list_copy(inner_rel->partexprs[cnt]));
+ 		joinrel->partexprs[cnt] = pkexpr;
+ 	}
+ }
